Index: /trunk/src/sys/arch/hpcmips/hpcmips/autoconf.c
===================================================================
--- /trunk/src/sys/arch/hpcmips/hpcmips/autoconf.c	(revision 151)
+++ /trunk/src/sys/arch/hpcmips/hpcmips/autoconf.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: autoconf.c,v 1.21 2008/02/12 17:30:57 joerg Exp $	*/
+/*	$NetBSD: autoconf.c,v 1.21.28.1 2010/12/29 08:16:22 matt Exp $	*/
 
 /*
@@ -78,5 +78,5 @@
 
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.21 2008/02/12 17:30:57 joerg Exp $");
+__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.21.28.1 2010/12/29 08:16:22 matt Exp $");
 
 #include <sys/param.h>
@@ -115,5 +115,5 @@
 
 	/* Configuration is finished, turn on interrupts. */
-	_splnone();	/* enable all source forcing SOFT_INTs cleared */
+	spl0();		/* enable all source forcing SOFT_INTs cleared */
 }
 
Index: /trunk/src/sys/arch/hpcmips/hpcmips/hpcapm_machdep.c
===================================================================
--- /trunk/src/sys/arch/hpcmips/hpcmips/hpcapm_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/hpcmips/hpcmips/hpcapm_machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: hpcapm_machdep.c,v 1.2 2005/12/11 12:17:33 christos Exp $	*/
+/*	$NetBSD: hpcapm_machdep.c,v 1.2.96.1 2010/12/29 08:16:22 matt Exp $	*/
 
 /*
@@ -30,5 +30,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: hpcapm_machdep.c,v 1.2 2005/12/11 12:17:33 christos Exp $");
+__KERNEL_RCSID(0, "$NetBSD: hpcapm_machdep.c,v 1.2.96.1 2010/12/29 08:16:22 matt Exp $");
 
 #include <sys/param.h>
@@ -92,34 +92,34 @@
 {
 #if NVRIP_COMMON > 0
-	 if (platid_match(&platid, &platid_mask_CPU_MIPS_VR_41XX)) {
-		 /*
-		  * disable all interrupts except PIU interrupt
-		  */
-		 vrip_intr_suspend();
-		 _spllower(~MIPS_INT_MASK_0);
+	if (platid_match(&platid, &platid_mask_CPU_MIPS_VR_41XX)) {
+		/*
+		 * disable all interrupts except PIU interrupt
+		 */
+		vrip_intr_suspend();
+		_spllower(~MIPS_INT_MASK_0);
 
-		 /*
-		  * SUSPEND instruction puts the CPU into power saveing
-		  * state until some interrupt occuer.
-		  * It sleeps until you push the power button.
-		  */
-		 __asm(".set noreorder");
-		 __asm(".word	" ___STRING(VR_OPCODE_SUSPEND));
-		 __asm("nop");
-		 __asm("nop");
-		 __asm("nop");
-		 __asm("nop");
-		 __asm("nop");
-		 __asm(".set reorder");
+		/*
+		 * SUSPEND instruction puts the CPU into power saveing
+		 * state until some interrupt occuer.
+		 * It sleeps until you push the power button.
+		 */
+		__asm(".set noreorder");
+		__asm(".word	" ___STRING(VR_OPCODE_SUSPEND));
+		__asm("nop");
+		__asm("nop");
+		__asm("nop");
+		__asm("nop");
+		__asm("nop");
+		__asm(".set reorder");
 
-		 splhigh();
-		 vrip_intr_resume();
-		 delay(1000); /* 1msec */
-	 }
+		splhigh();
+		vrip_intr_resume();
+		delay(1000); /* 1msec */
+	}
 #endif /* NVRIP_COMMON > 0 */
 #ifdef TX39XX
-	 if (platid_match(&platid, &platid_mask_CPU_MIPS_TX)) {
-		 tx39power_suspend_cpu();
-	 }
+	if (platid_match(&platid, &platid_mask_CPU_MIPS_TX)) {
+		tx39power_suspend_cpu();
+	}
 #endif
 }
Index: /trunk/src/sys/arch/hpcmips/hpcmips/interrupt.c
===================================================================
--- /trunk/src/sys/arch/hpcmips/hpcmips/interrupt.c	(revision 151)
+++ /trunk/src/sys/arch/hpcmips/hpcmips/interrupt.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: interrupt.c,v 1.13 2008/04/28 20:23:21 martin Exp $	*/
+/*	$NetBSD: interrupt.c,v 1.13.18.1 2010/12/29 08:16:22 matt Exp $	*/
 
 /*-
@@ -31,11 +31,14 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: interrupt.c,v 1.13 2008/04/28 20:23:21 martin Exp $");
+__KERNEL_RCSID(0, "$NetBSD: interrupt.c,v 1.13.18.1 2010/12/29 08:16:22 matt Exp $");
 
 #include "opt_vr41xx.h"
 #include "opt_tx39xx.h"
 
+#define __INTR_PRIVATE
+
 #include <sys/param.h>
 #include <sys/malloc.h>
+#include <sys/intr.h>
 
 #include <uvm/uvm_extern.h>
@@ -43,14 +46,9 @@
 #include <machine/sysconf.h>
 
-extern const u_int32_t __ipl_sr_bits_vr[];
-extern const u_int32_t __ipl_sr_bits_tx[];
-
-const u_int32_t *ipl_sr_bits;
-
 void
-intr_init()
+intr_init(void)
 {
 
-	ipl_sr_bits = CPUISMIPS3 ? __ipl_sr_bits_vr : __ipl_sr_bits_tx;
+	ipl_sr_map = CPUISMIPS3 ? __ipl_sr_map_vr : __ipl_sr_map_tx;
 }
 
@@ -65,8 +63,8 @@
  */
 void
-cpu_intr(u_int32_t status, u_int32_t cause, u_int32_t pc, u_int32_t ipending)
+cpu_intr(int ppl, vaddr_t pc, uint32_t status)
 {
 
-	(*platform.cpu_intr)(status, cause, pc, ipending);
+	(*platform.cpu_intr)(ppl, pc, status);
 }
 #endif /* VR41XX && TX39XX */
Index: /trunk/src/sys/arch/hpcmips/hpcmips/machdep.c
===================================================================
--- /trunk/src/sys/arch/hpcmips/hpcmips/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/hpcmips/hpcmips/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: machdep.c,v 1.96.10.5 2010/03/21 17:38:34 cliff Exp $	*/
+/*	$NetBSD: machdep.c,v 1.96.10.6 2010/12/29 08:16:22 matt Exp $	*/
 
 /*-
@@ -109,5 +109,5 @@
 
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.96.10.5 2010/03/21 17:38:34 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.96.10.6 2010/12/29 08:16:22 matt Exp $");
 
 #include "opt_vr41xx.h"
@@ -143,4 +143,5 @@
 #include <dev/cons.h>		/* cntab access (cpu_reboot) */
 
+#include <machine/locore.h>
 #include <machine/psl.h>
 #include <machine/sysconf.h>
Index: /trunk/src/sys/arch/hpcmips/include/intr.h
===================================================================
--- /trunk/src/sys/arch/hpcmips/include/intr.h	(revision 151)
+++ /trunk/src/sys/arch/hpcmips/include/intr.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: intr.h,v 1.22 2008/01/04 22:03:25 ad Exp $	*/
+/*	$NetBSD: intr.h,v 1.22.28.1 2010/12/29 08:16:22 matt Exp $	*/
 
 /*
@@ -34,60 +34,15 @@
 #define _HPCMIPS_INTR_H_
 
-#define	IPL_NONE	0	/* disable only this interrupt */
-#define	IPL_SOFTCLOCK	1	/* clock software interrupts (SI 0) */
-#define	IPL_SOFTBIO	1	/* bio software interrupts (SI 0) */
-#define	IPL_SOFTNET	2	/* network software interrupts (SI 1) */
-#define	IPL_SOFTSERIAL	2	/* serial software interrupts (SI 1) */
-#define	IPL_VM		3
-#define	IPL_SCHED	4
-#define	IPL_HIGH	4	/* disable all interrupts */
-
-#define	_IPL_N		5
-
-#define	_IPL_SI0_FIRST	IPL_SOFTCLOCK
-#define	_IPL_SI0_LAST	IPL_SOFTBIO
-
-#define	_IPL_SI1_FIRST	IPL_SOFTNET
-#define	_IPL_SI1_LAST	IPL_SOFTSERIAL
-
-/* Interrupt sharing types. */
-#define	IST_UNUSABLE	-1	/* interrupt cannot be used */
-#define	IST_NONE	0	/* none */
-#define	IST_PULSE	1	/* pulsed */
-#define	IST_EDGE	2	/* edge-triggered */
-#define	IST_LEVEL	3	/* level-triggered */
+#include <mips/intr.h>
 
 #ifdef _KERNEL
 #ifndef _LOCORE
-#include <mips/cpuregs.h>
-#include <mips/locore.h>
-
-extern const u_int32_t *ipl_sr_bits;
 
 void	intr_init(void);
 
-#define	spl0()		(void) _spllower(0)
-#define	splx(s)		(void) _splset(s)
-
-typedef int ipl_t;
-typedef struct {
-	ipl_t _sr;
-} ipl_cookie_t;
-
-static inline ipl_cookie_t
-makeiplcookie(ipl_t ipl)
-{
-
-	return (ipl_cookie_t){._sr = ipl_sr_bits[ipl]};
-}
-
-static inline int
-splraiseipl(ipl_cookie_t icookie)
-{
-
-	return _splraise(icookie._sr);
-}
-
-#include <sys/spl.h>
+#ifdef __INTR_PRIVATE
+extern const struct ipl_sr_map __ipl_sr_map_vr;
+extern const struct ipl_sr_map __ipl_sr_map_tx;
+#endif
 
 #endif /* !_LOCORE */
Index: /trunk/src/sys/arch/hpcmips/include/sysconf.h
===================================================================
--- /trunk/src/sys/arch/hpcmips/include/sysconf.h	(revision 151)
+++ /trunk/src/sys/arch/hpcmips/include/sysconf.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sysconf.h,v 1.13 2007/03/04 05:59:53 christos Exp $	*/
+/*	$NetBSD: sysconf.h,v 1.13.62.1 2010/12/29 08:16:22 matt Exp $	*/
 
 /*
@@ -63,5 +63,5 @@
 	 *	clock		-
 	 */
-	void	(*cpu_intr)(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
+	void	(*cpu_intr)(int, vaddr_t, u_int32_t);
 	void	(*cpu_idle)(void);
 	void	(*cons_init)(void);
Index: /trunk/src/sys/arch/hpcmips/tx/tx39.c
===================================================================
--- /trunk/src/sys/arch/hpcmips/tx/tx39.c	(revision 151)
+++ /trunk/src/sys/arch/hpcmips/tx/tx39.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: tx39.c,v 1.39.18.1 2010/02/01 04:18:31 matt Exp $ */
+/*	$NetBSD: tx39.c,v 1.39.18.2 2010/12/29 08:16:22 matt Exp $ */
 
 /*-
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: tx39.c,v 1.39.18.1 2010/02/01 04:18:31 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: tx39.c,v 1.39.18.2 2010/12/29 08:16:22 matt Exp $");
 
 #include "opt_vr41xx.h"
@@ -40,4 +40,5 @@
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/intr.h>
 
 #include <uvm/uvm_extern.h>
@@ -84,5 +85,5 @@
 #endif
 
-extern void TX_INTR(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
+extern void TX_INTR(int, vaddr_t, uint32_t);
 
 void	tx39clock_cpuspeed(int *, int *);
@@ -180,7 +181,7 @@
 {
 	char *page, *startaddr, *endaddr;
-	u_int32_t magic0, magic1;
-#define MAGIC0		(*(volatile u_int32_t *)(page + 0))
-#define MAGIC1		(*(volatile u_int32_t *)(page + 4))
+	uint32_t magic0, magic1;
+#define MAGIC0		(*(volatile uint32_t *)(page + 0))
+#define MAGIC1		(*(volatile uint32_t *)(page + 4))
 
 	startaddr = (char *)MIPS_PHYS_TO_KSEG1(start);
@@ -237,5 +238,5 @@
 {
 
-	goto *(u_int32_t *)MIPS_RESET_EXC_VEC;
+	goto *(uint32_t *)MIPS_RESET_EXC_VEC;
 }
 
Index: /trunk/src/sys/arch/hpcmips/vr/vr.c
===================================================================
--- /trunk/src/sys/arch/hpcmips/vr/vr.c	(revision 151)
+++ /trunk/src/sys/arch/hpcmips/vr/vr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: vr.c,v 1.51.22.1 2010/02/05 07:39:53 matt Exp $	*/
+/*	$NetBSD: vr.c,v 1.51.22.2 2010/12/29 08:16:23 matt Exp $	*/
 
 /*-
@@ -36,9 +36,11 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: vr.c,v 1.51.22.1 2010/02/05 07:39:53 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: vr.c,v 1.51.22.2 2010/12/29 08:16:23 matt Exp $");
 
 #include "opt_vr41xx.h"
 #include "opt_tx39xx.h"
 #include "opt_kgdb.h"
+
+#define	__INTR_PRIVATE
 
 #include <sys/param.h>
@@ -127,20 +129,17 @@
  * given interrupt priority level.
  */
-const u_int32_t __ipl_sr_bits_vr[_IPL_N] = {
-	0,					/* IPL_NONE */
-
-	MIPS_SOFT_INT_MASK_0,			/* IPL_SOFTCLOCK */
-
-	MIPS_SOFT_INT_MASK_0|
-		MIPS_SOFT_INT_MASK_1,		/* IPL_SOFTNET */
-
-	MIPS_SOFT_INT_MASK_0|
-		MIPS_SOFT_INT_MASK_1|
-		MIPS_INT_MASK_0,		/* IPL_VM */
-
-	MIPS_SOFT_INT_MASK_0|
-		MIPS_SOFT_INT_MASK_1|
-		MIPS_INT_MASK_0|
-		MIPS_INT_MASK_1,		/* IPL_SCHED */
+const struct ipl_sr_map __ipl_sr_map_vr = {
+    .sr_bits = {
+	[IPL_NONE] =		0,
+	[IPL_SOFTCLOCK] =	MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] =		MIPS_SOFT_INT_MASK,
+	[IPL_VM] =		MIPS_SOFT_INT_MASK
+				| MIPS_INT_MASK_0,
+	[IPL_SCHED] =		MIPS_SOFT_INT_MASK
+				| MIPS_INT_MASK_0
+				| MIPS_INT_MASK_1,
+	[IPL_DDB] =		MIPS_INT_MASK,
+	[IPL_VM] =		MIPS_INT_MASK,
+    },
 };
 
@@ -152,5 +151,5 @@
 
 void vr_init(void);
-void VR_INTR(u_int32_t, u_int32_t, u_int32_t, u_int32_t);
+void VR_INTR(int, vaddr_t, uint32_t);
 extern void vr_idle(void);
 STATIC void vr_cons_init(void);
@@ -163,6 +162,6 @@
  * CPU interrupt dispatch table (HwInt[0:3])
  */
-STATIC int vr_null_handler(void *, u_int32_t, u_int32_t);
-STATIC int (*vr_intr_handler[4])(void *, u_int32_t, u_int32_t) = 
+STATIC int vr_null_handler(void *, uint32_t, uint32_t);
+STATIC int (*vr_intr_handler[4])(void *, uint32_t, uint32_t) = 
 {
 	vr_null_handler,
@@ -429,4 +428,5 @@
 			    __FILE__, __LINE__);
 		}
+	}
 #else /* KGDB */
 	if (com_info->attach != NULL && (bootinfo->bi_cnuse&BI_CNUSE_SERIAL)) {
@@ -531,43 +531,30 @@
  */
 void
-VR_INTR(u_int32_t status, u_int32_t cause, u_int32_t pc, u_int32_t ipending)
-{
-	struct cpu_info *ci;
-
-	ci = curcpu();
-	ci->ci_idepth++;
+VR_INTR(int ppl, vaddr_t pc, uint32_t status)
+{
+	uint32_t ipending;
+	int ipl;
+
 	uvmexp.intrs++;
 
-	/* Deal with unneded compare interrupts occasionally so that we can
-	 * keep spllowersoftclock. */
-	if (ipending & MIPS_INT_MASK_5) {
-		mips3_cp0_compare_write(0);
-	}
-
-	if (ipending & MIPS_INT_MASK_1) {
-		_splset(MIPS_SR_INT_IE); /* for spllowersoftclock */
-		/* Remove the lower priority pending bits from status so that
-		 * spllowersoftclock will not happen if other interrupts are
-		 * pending. */
-		(*vr_intr_handler[1])(vr_intr_arg[1], pc, status & ~(ipending
-		& (MIPS_INT_MASK_0|MIPS_SOFT_INT_MASK_0|MIPS_SOFT_INT_MASK_1)));
-	}
-
-	if (ipending & MIPS_INT_MASK_0) {
-		_splset(MIPS_INT_MASK_1|MIPS_SR_INT_IE);
-		(*vr_intr_handler[0])(vr_intr_arg[0], pc, status);
-	}
-	ci->ci_idepth--;
-
-#ifdef __HAVE_FAST_SOFTINTS
-	ipending &= MIPS_SOFT_INT_MASK;
-	if (ipending == 0)
-		return;
-	softint_process(ipending);
-#endif
+	while (ppl < (ipl = splintr(&ipending))) {
+		/* Deal with unneded compare interrupts occasionally so that
+		 * we can keep spllowersoftclock. */
+		if (ipending & MIPS_INT_MASK_5) {
+			mips3_cp0_compare_write(0);
+		}
+
+		if (ipending & MIPS_INT_MASK_1) {
+			(*vr_intr_handler[1])(vr_intr_arg[1], pc, ipending);
+		}
+
+		if (ipending & MIPS_INT_MASK_0) {
+			(*vr_intr_handler[0])(vr_intr_arg[0], pc, status);
+		}
+	}
 }
 
 void *
-vr_intr_establish(int line, int (*ih_fun)(void *, u_int32_t, u_int32_t),
+vr_intr_establish(int line, int (*ih_fun)(void *, uint32_t, uint32_t),
     void *ih_arg)
 {
@@ -591,5 +578,5 @@
 
 int
-vr_null_handler(void *arg, u_int32_t pc, u_int32_t status)
+vr_null_handler(void *arg, uint32_t pc, uint32_t status)
 {
 
Index: /trunk/src/sys/arch/i386/i386/machdep.c
===================================================================
--- /trunk/src/sys/arch/i386/i386/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/i386/i386/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: machdep.c,v 1.644.4.10.4.1 2010/04/21 00:33:50 matt Exp $	*/
+/*	$NetBSD: machdep.c,v 1.644.4.10.4.2 2011/05/20 08:11:20 matt Exp $	*/
 
 /*-
@@ -68,5 +68,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.644.4.10.4.1 2010/04/21 00:33:50 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.644.4.10.4.2 2011/05/20 08:11:20 matt Exp $");
 
 #include "opt_beep.h"
@@ -249,7 +249,4 @@
 int	physmem;
 
-unsigned int cpu_feature;
-unsigned int cpu_feature2;
-unsigned int cpu_feature_padlock;
 int	cpu_class;
 int	i386_fpu_present;
@@ -1433,6 +1430,4 @@
 #endif
 	cpu_probe(&cpu_info_primary);
-	cpu_feature = cpu_info_primary.ci_feature_flags;
-	cpu_feature2 = cpu_info_primary.ci_feature2_flags;
 	cpu_feature_padlock = cpu_info_primary.ci_padlock_flags;
 
@@ -1442,5 +1437,6 @@
 #ifdef XEN
 	/* not on Xen... */
-	cpu_feature &= ~(CPUID_PGE|CPUID_PSE|CPUID_MTRR|CPUID_FXSR|CPUID_NOX);
+	cpu_feature &= ~(CPUID_PGE|CPUID_PSE|CPUID_MTRR|CPUID_FXSR);
+	cpu_feature3 &= ~(CPUID_NOX);
 	lwp0.l_addr->u_pcb.pcb_cr3 = PDPpaddr - KERNBASE;
 	__PRINTK(("pcb_cr3 0x%lx cr3 0x%lx\n",
Index: /trunk/src/sys/arch/i386/i386/pmc.c
===================================================================
--- /trunk/src/sys/arch/i386/i386/pmc.c	(revision 151)
+++ /trunk/src/sys/arch/i386/i386/pmc.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: pmc.c,v 1.17 2008/05/11 14:44:54 ad Exp $	*/
+/*	$NetBSD: pmc.c,v 1.17.16.1 2011/05/20 08:11:20 matt Exp $	*/
 
 /*-
@@ -39,5 +39,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: pmc.c,v 1.17 2008/05/11 14:44:54 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: pmc.c,v 1.17.16.1 2011/05/20 08:11:20 matt Exp $");
 
 #include <sys/param.h>
@@ -51,4 +51,5 @@
 #include <machine/cpu_counter.h>
 #include <machine/cputypes.h>
+#include <machine/cpuvar.h>
 
 static int pmc_initialized;
Index: /trunk/src/sys/arch/i386/i386/trap.c
===================================================================
--- /trunk/src/sys/arch/i386/i386/trap.c	(revision 151)
+++ /trunk/src/sys/arch/i386/i386/trap.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: trap.c,v 1.241.4.1 2009/03/27 17:25:15 msaitoh Exp $	*/
+/*	$NetBSD: trap.c,v 1.241.4.1.4.1 2011/05/20 08:11:21 matt Exp $	*/
 
 /*-
@@ -69,5 +69,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: trap.c,v 1.241.4.1 2009/03/27 17:25:15 msaitoh Exp $");
+__KERNEL_RCSID(0, "$NetBSD: trap.c,v 1.241.4.1.4.1 2011/05/20 08:11:21 matt Exp $");
 
 #include "opt_ddb.h"
@@ -132,4 +132,5 @@
 void trap(struct trapframe *);
 void trap_tss(struct i386tss *, int, int);
+void trap_return_fault_return(struct trapframe *) __dead;
 
 #ifdef KVM86
@@ -277,5 +278,5 @@
 	int type = frame->tf_trapno;
 	struct pcb *pcb;
-	extern char fusubail[], kcopy_fault[], trapreturn[], IDTVEC(osyscall)[];
+	extern char fusubail[], kcopy_fault[], IDTVEC(osyscall)[];
 	struct trapframe *vframe;
 	ksiginfo_t ksi;
@@ -393,65 +394,76 @@
 		/*
 		 * Check for failure during return to user mode.
+		 * This can happen loading invalid values into the segment
+		 * registers, or during the 'iret' itself.
 		 *
 		 * We do this by looking at the instruction we faulted on.
 		 * The specific instructions we recognize only happen when
 		 * returning from a trap, syscall, or interrupt.
-		 *
-		 * At this point, there are (at least) two trap frames on
-		 * the kernel stack; we presume here that we faulted while
-		 * loading our registers out of the outer one.
 		 */
+
+kern_pagefault:
+		KSI_INIT_TRAP(&ksi);
+		ksi.ksi_signo = SIGSEGV;
+		ksi.ksi_code = SEGV_ACCERR;
+		ksi.ksi_trap = type;
+
 		switch (*(u_char *)frame->tf_eip) {
 		case 0xcf:	/* iret */
-			vframe = (void *)((int)&frame->tf_esp -
+			/*
+			 * The 'iret' instruction faulted, so we have the
+			 * 'user' registers saved after the kernel %eip:%cs:%fl
+			 * of the 'iret' and below that the user %eip:%cs:%fl
+			 * the 'iret' was processing.
+			 * We must delete the 3 words of kernel return address
+			 * from the stack to generate a normal stack frame
+			 * (eg for sending a SIGSEGV).
+			 */
+			vframe = (void *)((int *)frame + 3);
+			if (KERNELMODE(vframe->tf_cs, vframe->tf_eflags))
+				goto we_re_toast;
+			memmove(vframe, frame,
 			    offsetof(struct trapframe, tf_eip));
+			/* Set the faulting address to the user %eip */
+			ksi.ksi_addr = (void *)vframe->tf_eip;
 			break;
 		case 0x8e:
 			switch (*(uint32_t *)frame->tf_eip) {
-			case 0x0c245c8e:	/* movl 0xc(%esp,1),%ds */
-			case 0x0824448e:	/* movl 0x8(%esp,1),%es */
-			case 0x0424648e:	/* movl 0x4(%esp,1),%fs */
-			case 0x00246c8e:	/* movl 0x0(%esp,1),%gs */
+			case 0x8e242c8e:	/* mov (%esp),%gs */
+			case 0x00246c8e:	/* mov 0x0(%esp),%gs */
+			case 0x0424648e:	/* mov 0x4(%esp),%fs */
+			case 0x0824448e:	/* mov 0x8(%esp),%es */
+			case 0x0c245c8e:	/* mov 0xc(%esp),%ds */
 				break;
 			default:
 				goto we_re_toast;
 			}
-			vframe = (void *)(int)&frame->tf_esp;
+			/*
+			 * We faulted loading one if the user segment registers.
+			 * The stack frame containing the user registers is
+			 * still valid and is just below the %eip:%cs:%fl of
+			 * the kernel fault frame.
+			 */
+			vframe = (void *)(&frame->tf_eflags + 1);
+			if (KERNELMODE(vframe->tf_cs, vframe->tf_eflags))
+				goto we_re_toast;
+			/* There is no valid address for the fault */
 			break;
 		default:
 			goto we_re_toast;
 		}
-		if (KERNELMODE(vframe->tf_cs, vframe->tf_eflags))
-			goto we_re_toast;
-
 		/*
-		 * Arrange to signal the thread, which will reset its
-		 * registers in the outer frame.  This also allows us to
-		 * capture the invalid register state in sigcontext,
-		 * packaged up with the signal delivery.  We restart
-		 * on return at 'trapreturn', acting as if nothing
-		 * happened, restarting the return to user with our new
-		 * set of registers.
-		 *
-		 * Clear PSL_NT.  It can be set by userland because setting
-		 * it isn't a privileged operation.
-		 *
-		 * Set PSL_I.  Otherwise, if SIGSEGV is ignored, we'll
-		 * continue to generate traps infinitely with
-		 * interrupts disabled.
+		 * We might have faulted trying to execute the
+		 * trampoline for a local (nested) signal handler.
+		 * Only generate SIGSEGV if the user %cs isn't changed.
+		 * (This is only strictly necessary in the 'iret' case.)
 		 */
-		frame->tf_ds = GSEL(GDATA_SEL, SEL_KPL);
-		frame->tf_es = GSEL(GDATA_SEL, SEL_KPL);
-		frame->tf_gs = GSEL(GDATA_SEL, SEL_KPL);
-		frame->tf_fs = GSEL(GCPU_SEL, SEL_KPL);
-		frame->tf_eip = (uintptr_t)trapreturn;
-		frame->tf_eflags = (frame->tf_eflags & ~PSL_NT) | PSL_I;
-		KSI_INIT_TRAP(&ksi);
-		ksi.ksi_signo = SIGSEGV;
-		ksi.ksi_addr = (void *)rcr2();
-		ksi.ksi_code = SEGV_ACCERR;
-		ksi.ksi_trap = type & ~T_USER;
-		(*p->p_emul->e_trapsignal)(l, &ksi);
-		return;
+		if (!pmap_exec_fixup(&p->p_vmspace->vm_map, vframe, pcb)) {
+			/* Save outer frame for any signal return */
+			l->l_md.md_regs = vframe;
+			(*p->p_emul->e_trapsignal)(l, &ksi);
+		}
+		/* Return to user by reloading the user frame */
+		trap_return_fault_return(vframe);
+		/* NOTREACHED */
 
 	case T_PROTFLT|T_USER:		/* protection fault */
@@ -490,4 +502,21 @@
 		case T_ALIGNFLT|T_USER:
 			ksi.ksi_code = BUS_ADRALN;
+			break;
+		case T_PROTFLT|T_USER:
+#ifdef VM86
+			if (frame->tf_eflags & PSL_VM) {
+				vm86_gpfault(l, type & ~T_USER);
+				goto out;
+			}
+#endif
+			/*
+			 * If pmap_exec_fixup does something,
+			 * let's retry the trap.
+			 */
+			if (pmap_exec_fixup(&p->p_vmspace->vm_map, frame, pcb)){
+				goto out;
+			}
+			ksi.ksi_signo = SIGSEGV;
+			ksi.ksi_code = SEGV_ACCERR;
 			break;
 		default:
@@ -708,5 +737,5 @@
 			printf("uvm_fault(%p, %#lx, %d) -> %#x\n",
 			    map, va, ftype, error);
-			goto we_re_toast;
+			goto kern_pagefault;
 		}
 		if (error == ENOMEM) {
Index: /trunk/src/sys/arch/i386/i386/vector.S
===================================================================
--- /trunk/src/sys/arch/i386/i386/vector.S	(revision 151)
+++ /trunk/src/sys/arch/i386/i386/vector.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: vector.S,v 1.42.6.2 2009/04/04 17:39:09 snj Exp $	*/
+/*	$NetBSD: vector.S,v 1.42.6.2.4.1 2011/05/20 08:11:21 matt Exp $	*/
 
 /*
@@ -66,5 +66,5 @@
 
 #include <machine/asm.h>
-__KERNEL_RCSID(0, "$NetBSD: vector.S,v 1.42.6.2 2009/04/04 17:39:09 snj Exp $");
+__KERNEL_RCSID(0, "$NetBSD: vector.S,v 1.42.6.2.4.1 2011/05/20 08:11:21 matt Exp $");
 
 #include "opt_ddb.h"
@@ -1084,4 +1084,16 @@
 	jmp	1b
 
+/*
+ * trap() calls here when it detects a fault in INTRFASTEXIT (loading the
+ * segment registers or during the iret itself).
+ * The address of the (possibly reconstructed) user trap frame is
+ * passed as an argument.
+ * Typically the code will have raised a SIGSEGV which will be actioned
+ * by the code below.
+ */
+_C_LABEL(trap_return_fault_return):	.globl	trap_return_fault_return
+	mov	4(%esp),%esp	/* frame for user return */
+	jmp	_C_LABEL(trapreturn)
+
 /* LINTSTUB: Ignore */
 NENTRY(alltraps)
Index: /trunk/src/sys/arch/i386/isa/npx.c
===================================================================
--- /trunk/src/sys/arch/i386/isa/npx.c	(revision 151)
+++ /trunk/src/sys/arch/i386/isa/npx.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: npx.c,v 1.129.10.5 2008/11/27 03:37:02 snj Exp $	*/
+/*	$NetBSD: npx.c,v 1.129.10.5.4.1 2011/05/20 08:11:21 matt Exp $	*/
 
 /*-
@@ -97,5 +97,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: npx.c,v 1.129.10.5 2008/11/27 03:37:02 snj Exp $");
+__KERNEL_RCSID(0, "$NetBSD: npx.c,v 1.129.10.5.4.1 2011/05/20 08:11:21 matt Exp $");
 
 #if 0
@@ -125,4 +125,5 @@
 
 #include <machine/cpufunc.h>
+#include <machine/cpuvar.h>
 #include <machine/pcb.h>
 #include <machine/trap.h>
Index: /trunk/src/sys/arch/i386/stand/misc/Makefile
===================================================================
--- /trunk/src/sys/arch/i386/stand/misc/Makefile	(revision 151)
+++ /trunk/src/sys/arch/i386/stand/misc/Makefile	(revision 152)
@@ -1,7 +1,7 @@
-#	$NetBSD: Makefile,v 1.6 2005/12/11 12:17:49 christos Exp $
+#	$NetBSD: Makefile,v 1.6.96.1 2011/05/20 08:11:21 matt Exp $
 
 MISC_FILES=	rawrite.c
 UUDECODE_FILES=	pfdisk.doc pfdisk.exe pfdisktc.zip \
-		rawr32.zip rawr32src.zip \
+		rawr32.exe \
 		rawrite.doc rawrite.exe
 
Index: /trunk/src/sys/arch/mips/conf/files.mips
===================================================================
--- /trunk/src/sys/arch/mips/conf/files.mips	(revision 151)
+++ /trunk/src/sys/arch/mips/conf/files.mips	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: files.mips,v 1.58.24.11 2010/02/28 23:45:07 matt Exp $
+#	files.mips,v 1.58.24.14 2011/04/29 08:26:19 matt Exp
 #
 
@@ -7,7 +7,7 @@
 					# and the rest...
 					# MIPS1	MIPS2 MIPS3 MIPS4 MIPS5
-					# MIPS32 MIPS64
+					# MIPS32 MIPS32R2 MIPS64 MIPS64R2
+					# MIPS64_RMIXL MIPS64R2_RMIXL
 					# MIPS3_4100
-					# MIPS3_5900
 					# ENABLE_MIPS_TX3900
 					# ENABLE_MIPS_R4700
@@ -18,14 +18,19 @@
 
 defflag	opt_ddb.h		DDB_TRACE
+defflag	opt_ddb.h		MIPS_DDB_WATCH
 
 file	arch/mips/mips/locore_mips1.S		mips1
-file	arch/mips/mips/locore_mips3.S		mips3 | mips4 | mips32 | mips64
-file	arch/mips/mips/mips3_subr.S		(mips3 | mips4) & !mips3_5900
-file	arch/mips/mips/mips5900_subr.S		mips3 & mips3_5900
+file	arch/mips/mips/locore_mips3.S		mips3|mips4|mips32|mips32r2|mips64|mips64r2|mips64_rmixl|mips64r2_rmixl
+file	arch/mips/mips/mips3_subr.S		mips3|mips4
 file	arch/mips/mips/mips32_subr.S		mips32
+file	arch/mips/mips/mips32r2_subr.S		mips32r2
 file	arch/mips/mips/mips64_subr.S		mips64
+file	arch/mips/mips/mips64r2_subr.S		mips64r2
+file	arch/mips/mips/mips64_rmixl_subr.S	mips64_rmixl
+file	arch/mips/mips/mips64r2_rmixl_subr.S	mips64r2_rmixl
 file	arch/mips/mips/sigcode.S
 file	arch/mips/mips/copy.S
-file	arch/mips/mips/lock_stubs.S
+file	arch/mips/mips/lock_stubs_llsc.S	multiprocessor | tsar
+file	arch/mips/mips/lock_stubs_ras.S
 file	arch/mips/mips/locore_funcs.S
 file	arch/mips/mips/spl.S
@@ -44,5 +49,5 @@
 file	arch/mips/mips/trap.c			# trap handlers
 file	arch/mips/mips/syscall.c		# syscall entries
-file	arch/mips/mips/mips_fixup.c		(mips3 | mips4 | mips32 | mips64)
+file	arch/mips/mips/mips_fixup.c
 file	arch/mips/mips/mips_fpu.c
 file	arch/mips/mips/mips_machdep.c		!tsar
@@ -53,5 +58,5 @@
 file	arch/mips/mips/process_machdep.c
 file	arch/mips/mips/cpu_exec.c
-file	arch/mips/mips/wired_map.c (mips3|mips4|mips32|mips64) & enable_mips3_wired_map
+file	arch/mips/mips/wired_map.c (mips3|mips4|mips32|mips32r2|mips64|mips64r2|mips64_rmixl|mips64r2_rmixl) & enable_mips3_wired_map
 
 file	arch/mips/mips/cache.c			!tsar
@@ -63,11 +68,11 @@
 file	arch/mips/mips/cache_r5k.c		mips3 | mips4
 file	arch/mips/mips/cache_r5k_subr.S		mips3 | mips4
-file	arch/mips/mips/cache_r5900.c		mips3 & mips3_5900
 file	arch/mips/mips/cache_r10k.c	(mips3|mips4) & enable_mips4_cache_r10k
-file	arch/mips/mips/cache_mipsNN.c		(mips32 | mips64) & !tsar
+file	arch/mips/mips/cache_mipsNN.c		(mips32|mips32r2|mips64|mips64r2|mips64_rmixl|mips64r2_rmixl) & !tsar
 
 file	arch/mips/mips/mips_fputrap.c		!nofpu | fpemul
 file	arch/mips/mips/mips_emul.c
 file	arch/mips/mips/fp.S			!nofpu | fpemul
+file	arch/mips/mips/bds_emul.S		fpemul
 
 file	arch/mips/mips/procfs_machdep.c		procfs
Index: /trunk/src/sys/arch/mips/conf/files.sibyte
===================================================================
--- /trunk/src/sys/arch/mips/conf/files.sibyte	(revision 151)
+++ /trunk/src/sys/arch/mips/conf/files.sibyte	(revision 152)
@@ -68,2 +68,4 @@
 
 file	arch/sbmips/sbmips/rtc.c		xirtc | m41t81rtc
+
+file	arch/mips/sibyte/dev/sbbuswatch.c
Index: /trunk/src/sys/arch/mips/conf/kern.ldscript
===================================================================
--- /trunk/src/sys/arch/mips/conf/kern.ldscript	(revision 151)
+++ /trunk/src/sys/arch/mips/conf/kern.ldscript	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: kern.ldscript,v 1.5 2006/08/27 04:48:44 tsutsui Exp $ */
+/* $NetBSD: kern.ldscript,v 1.5.78.1 2010/12/22 06:13:36 matt Exp $ */
 
 /*  ldscript for NetBSD/mips kernels and LKMs */
@@ -16,4 +16,7 @@
     _ftext = . ;
     *(.text)
+    __stub_start = . ;
+    *(.stub*)
+    __stub_end = . ;
     *(.gnu.warning)
   } =0
